<?
/*
Source code example for Web Database Applications

Unless otherwise stated, the source code distributed with this book can be
redistributed in source or binary form so long as an acknowledgment appears
in derived source files.
The citation should list that the code comes from Hugh E.
Williams and David Lane, "Web Database Application with PHP and MySQL"
published by O'Reilly & Associates.
This code is under copyright and cannot be included in any other book,
publication, or educational product without permission from O'Reilly &
Associates.
No warranty is attached; we cannot take responsibility for errors or fitness
for use.
*/
?>
<?php

// See if the HTTP request has set $count as the 
// result of a Cookie called "count"
if(!isset($count)) {
  // No cookie called count, set the counter to zero  
  $count = 0;

  // .. and set a cookie with the "start" time
  // of this stateful interaction
  $start = time();
  setcookie("start", $start, time()+600, "/", "", 0);

} else {
    $count++;
}

// Set a cookie "count" with the current value
setcookie("count", $count, time()+600, "/", "", 0);

?>
<!DOCTYPE HTML PUBLIC 
   "-//W3C//DTD HTML 4.0 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
  <title>Cookie State Test</title>
</head>
  <body>
    <p>This page comes with cookies: Enjoy! 
    <br>count = <?=$count ?>.
    <br>start = <?=$start ?>.
    <p>This session has lasted 
      <?php 
        $duration = time() - $start; 
    echo "$duration"; 
      ?> 
      seconds.
  </body>
</html>  
