<?
/*
Source code example for Web Database Applications

Unless otherwise stated, the source code distributed with this book can be
redistributed in source or binary form so long as an acknowledgment appears
in derived source files.
The citation should list that the code comes from Hugh E.
Williams and David Lane, "Web Database Application with PHP and MySQL"
published by O'Reilly & Associates.
This code is under copyright and cannot be included in any other book,
publication, or educational product without permission from O'Reilly &
Associates.
No warranty is attached; we cannot take responsibility for errors or fitness
for use.
*/
?>
<?php

//
// Function that returns the HTML FORM that is 
// used to collect the user-name and password
//
function login_page($errorMessage)
{
  // Generate the Login-in page
  ?>
  
<!DOCTYPE HTML PUBLIC 
    "-//W3C//DTD HTML 4.0 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd" >
  <html>
  <head>
     <title>Winestore Login Page</title>
  </head>
  <body>
    <h2>Winestore Login Page</h2>
    <form method="POST" action="example.9-9.php">

  <? 
  // Include the formatted error message

  if (isset($errorMessage))
    echo 
      "<h3><font color=red>$errorMessage</font></h3>";

  // Generate the login <form> layout
  ?>
    <table>
      <tr><td>Enter your user-name:</td>
          <td><input type="text" size=10 
                   maxlength=10 
                   name="formUsername"></td></tr>     
      <tr><td>Enter your password:</td>
          <td><input type="password" size=10 
                   maxlength=10
                   name="formPassword"></td></tr>
    </table>
    <p><input type="submit" value="Log in">
    </form>
    </body>
  </html>
  <?
}

//
// Function that returns HTML page showing that 
// the user with the $currentLoginName is logged on
//
function logged_on_page($currentLoginName)
{

  // Generate the page that shows the user 
  // is already authenticated and authorized
  ?>

<!DOCTYPE HTML PUBLIC 
      "-//W3C//DTD HTML 4.0 Transitional//EN"
      "http://www.w3.org/TR/html4/loose.dtd" >
  <html>
  <head>
     <title>Winestore</title>
  </head>
  <body>
    <h2>Winestore</h2>
    <h2>You are currently logged in as 
        <?=$currentLoginName ?></h2>
    <a href="example.9-10.php">Logout</a>
  </body>
  </html>
  <?
}

// Main
session_start();

// Check if we have established a session
if (isset($HTTP_SESSION_VARS["authenticatedUser"]))
{
  // There is a user logged on
  logged_on_page(
          $HTTP_SESSION_VARS["authenticatedUser"]);
}
else
{
  // No session established, no POST variables 
  // display the login form + any error message
  login_page($HTTP_SESSION_VARS["loginMessage"]);

  session_destroy();
}
?>  
