<?
/*
Source code example for Web Database Applications

Unless otherwise stated, the source code distributed with this book can be
redistributed in source or binary form so long as an acknowledgment appears
in derived source files.
The citation should list that the code comes from Hugh E.
Williams and David Lane, "Web Database Application with PHP and MySQL"
published by O'Reilly & Associates.
This code is under copyright and cannot be included in any other book,
publication, or educational product without permission from O'Reilly &
Associates.
No warranty is attached; we cannot take responsibility for errors or fitness
for use.
*/
?>
<?
   // Trigger an error condition
   function showerror()
   {
      if (mysql_errno() || mysql_error())      
         trigger_error("MySQL error: " .
                        mysql_errno() . 
                        " : " . mysql_error(), 
                        E_USER_ERROR);
      else 
         trigger_error("Could not connect to DBMS", E_USER_ERROR);
   }

   // Abort on error. Deletes session variables to leave
   // us in a clean state
   function errorHandler($errno, $errstr, $errfile, $errline)
   {
      switch ($errno)
      {
         case E_USER_NOTICE:
         case E_USER_WARNING:
         case E_WARNING:
         case E_NOTICE:
         case E_CORE_WARNING:
         case E_CORE_NOTICE:
         case E_COMPILE_WARNING:
            break;
         case E_USER_ERROR:
         case E_ERROR:
         case E_PARSE:
         case E_CORE_ERROR:
         case E_COMPILE_ERROR:
            session_start();

            if (session_is_registered("message"))
               session_unregister("message");

            if (session_is_registered("order_no"))
               session_unregister("order_no");

            $errorString = "Winestore system error: $errstr (# $errno).<br>\n" .
                           "Please report the following to the administrator:<br>\n" .
                           "Error in line $errline of file $errfile.<br>\n";

            // Send the error to the administrator by email
            error_log($errorString, 1, "hugh");
?>
<h2>Hugh and Dave's Online wines is temporarily unavailable</h2>
The following has been reported to the administrator:
<br><b><font color="red"><?=$errorString;?></b></font>
<?php
            // Stop the system
            die();
         default:
            break;
      }
   }
?>
