<?
/*
Source code example for Web Database Applications

Unless otherwise stated, the source code distributed with this book can be
redistributed in source or binary form so long as an acknowledgment appears
in derived source files.
The citation should list that the code comes from Hugh E.
Williams and David Lane, "Web Database Application with PHP and MySQL"
published by O'Reilly & Associates.
This code is under copyright and cannot be included in any other book,
publication, or educational product without permission from O'Reilly &
Associates.
No warranty is attached; we cannot take responsibility for errors or fitness
for use.
*/
?>
<?php
   // This script redirects the browser to another script,
   // depending on what parameters are provided. It is used 
   // for processing several submit buttons from an HTML <form>

   include 'include.inc';

   set_error_handler("errorHandler");

   session_start();

   // Clean up the data, and save the results in
   // an array
   foreach($HTTP_GET_VARS as $varname => $value)
           $parameters[$varname] = clean($value, 10);

   // Did they want to view the cart?
   if (!empty($parameters["view"]))
   {
      // Redirect the browser to the cart page
      // using the HTTP response header "Location:"
      header("Location: example.cart.2.php");
      exit;
   }

   // Did they want to go home?
   if (!empty($parameters["home"]))
   {
      // Redirect the browser to the home page
      // using the HTTP response header "Location:"
      header("Location: example.cart.1.php");
      exit;
   }

   // Did they want to empty the cart?
   if (!empty($parameters["empty"]))
   {
      // Redirect the browser to the empty page
      // using the HTTP response header "Location:"
      header("Location: example.cart.4.php");
      exit;
   }

   // Did they want to update the quantities?
   if (!empty($parameters["update"]))
   {
      // Redirect the browser to the update page
      // using the HTTP response header "Location:"
      header("Location: example.cart.6.php?$QUERY_STRING");
      exit;
   }

   // Did they want to finalise the purchase?
   if (!empty($parameters["search"]))
   {
      // Redirect the browser to the search input page
      // using the HTTP response header "Location:"
      header("Location: example.search.1.php?$QUERY_STRING");
      exit;
   }

   // Did they want to login to the site?
   if (!empty($parameters["login"]))
   {
      // Save the referer page for later redirection
      if (session_is_registered("referer"))
         session_unregister("referer");
      session_register("referer");
      $referer = $HTTP_REFERER;

      // Redirect the browser to the login page
      // using the HTTP response header "Location:"
      header("Location: example.order.1.php?$QUERY_STRING");
      exit;
   }

   if (!empty($parameters["logout"]))
   {
      // Save the referer page for later redirection
      if (session_is_registered("referer"))
         session_unregister("referer");
      session_register("referer");
      $referer = $HTTP_REFERER;

      // Redirect the browser to the logout page
      // using the HTTP response header "Location:"
      header("Location: example.order.2.php?$QUERY_STRING");
      exit;
   }
   
   // Did they want to finalise the purchase?
   if (!empty($parameters["buy"]))
   {
      // Redirect the browser to the purchase page
      // using the HTTP response header "Location:"
      header("Location: example.order.3.php?$QUERY_STRING");
      exit;
   }


   // Did they want to finalise the purchase?
   if (!empty($parameters["account"]))
   {
      // Redirect the browser to the customer account page
      // using the HTTP response header "Location:"
      header("Location: example.customer.2.php");
      exit;
   }

   // They got here without providing an option, so
   // there is a problem
   echo "You arrived here unexpectedly.";
?>
