<?
/*
Source code example for Web Database Applications

Unless otherwise stated, the source code distributed with this book can be
redistributed in source or binary form so long as an acknowledgment appears
in derived source files.
The citation should list that the code comes from Hugh E.
Williams and David Lane, "Web Database Application with PHP and MySQL"
published by O'Reilly & Associates.
This code is under copyright and cannot be included in any other book,
publication, or educational product without permission from O'Reilly &
Associates.
No warranty is attached; we cannot take responsibility for errors or fitness
for use.
*/
?>
<?php
  // This script logs a user out and redirects 
  // to the calling page.

  include 'include.inc';

  set_error_handler("errorHandler");

  // Restore the session
  session_start();

  // Is the user logged in?
  if (session_is_registered("loginUsername"))
     session_unregister("loginUsername");
  else
  {
     // Register a message to show the user
     session_register("message");
     $message = "Error: you are not logged in!";
  }

  // Redirect the browser back to the calling page
  if (session_is_registered("referer"))
  {  
     // Delete the redirection session variable
     session_unregister("referer");

     // Then, use it to redirect to the calling page
     header("Location: $referer");
     exit;
  }
  else
     header("Location: example.cart.1.php");
?>
